/* From Ruby on Rails */

function hasAttributeIESafe(element, attribute) {

	var attributeNode = element.getAttributeNode(attribute);
	if (attributeNode) {
		if (attributeNode.specified) {
			return true;
		}
		return false;
	}
}

/* Scan all portlet tags in the HTML document 
 * and insert appropriate frame tags, not provided by Plone default CSS, around them
 *
 * Plone default portlets don't propeply clost porlets with lastItem and 
 * portletBottomLeft/portletBottomRight tags are nested inside lastItem 
 * making image frames impossible.
 */

function scanForPortlets() {
    // terminate if we hit a non-compliant DOM implementation
    if (!W3CDOM) { return false; }
           
    tags = document.getElementsByTagName('dl');
    for (i=0; i < tags.length; i++) {
        
        if (hasAttributeIESafe(tags[i], 'class')) {
    
        	//clazz = tags[i].getAttribute("class");
        	//alert("Class:" + clazz);
        
        	if(tags[i].className.indexOf('portlet') !=-1 ) {
    	    	             
	            portletFinalizer = document.createElement("dd");
	            portletFinalizer.setAttribute("class", "happyPortletFinalizer");
	            	
				tags[i].appendChild(portletFinalizer)
				
				// WELL FUCK. IE doesn't load CSS background image if the element has been created dynamically
				portletFinalizer.style.cssText = "padding: 0; margin: 0; background: #ddDDdd url('portlet_images/happy_portlet_3x1.gif') no-repeat bottom left;";
				
			}
        }
    }
};

/* Make sure that the page height is at least one screenful 

   Taken from: http://www.alistapart.com/articles/footers/
*/

function getWindowHeight() {
	var windowHeight=0;
	if (typeof(window.innerHeight)=='number') {
		windowHeight=window.innerHeight;
	} else {
		if (document.documentElement && document.documentElement.clientHeight) {
			windowHeight= document.documentElement.clientHeight;
		} else {
			if (document.body&&document.body.clientHeight) {
				windowHeight=document.body.clientHeight;
			}
		}
	}
	return windowHeight;
}

function adjustFooter() {
	if (document.getElementById) {
		var windowHeight=getWindowHeight();
		if (windowHeight>0) {

			totalHeight = document.getElementById('column-wrapper').offsetHeight;

			var footerElement= document.getElementById('footer-row');
			var footerHeight=footerElement.offsetHeight;
			
			if (windowHeight > totalHeight) {			
				/* Expand main content area to fill empty space */
				var contentElement= document.getElementById('content-row');
				var contentHeight = contentElement.offsetHeight;
				contentElement.style.height=contentHeight+(windowHeight-totalHeight) + "px";
			} 
		}
	}
}

function patchPage() {
	// these must be executed in this order
	scanForPortlets();
	adjustFooter();
}

registerPloneFunction(patchPage);

